searchNodes=[{"type":"module","title":"Goth","doc":"A Goth token server.","ref":"Goth.html"},{"type":"function","title":"Goth.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Goth.html#child_spec/1"},{"type":"function","title":"Goth.fetch/2","doc":"Fetches the token from the cache. If the token is not in the cache, this function blocks for timeout milliseconds (defaults to 5000 ) while it is attempted to fetch it in the background. To fetch the token bypassing the cache, see Goth.Token.fetch/1 .","ref":"Goth.html#fetch/2"},{"type":"function","title":"Goth.fetch!/2","doc":"Fetches the token, erroring if it is missing. See fetch/2 for more information.","ref":"Goth.html#fetch!/2"},{"type":"function","title":"Goth.start_link/1","doc":"Starts the server. When the server is started, we attempt to fetch the token and store it in internal cache. If we fail, we'll retry with backoff. Options :name - a unique name to register the server under. It can be any term. :source - the source to retrieve the token from. Supported values include: {:service_account, credentials} - fetch token using service account credentials {:refresh_token, credentials} - fetch token using refresh token :metadata - fetching token using Google internal metadata service If :source is not set, Goth will: Check application environment. You can set it with: config :goth, json: File.read!(&quot;credentials.json&quot;) . Check GOOGLE_APPLICATION_CREDENTIALS env variable that contains path to credentials file. Check GOOGLE_APPLICATION_CREDENTIALS_JSON env variable that contains credentials JSON. Check ~/.config/gcloud/application_default_credentials.json file. Check ~/.config/gcloud/configurations/config_default for project id and email address for SDK users. Check Google internal metadata service Otherwise, raise an error. See documentation of the &quot;Source&quot; section in Goth.Token.fetch/1 documentation for more information. :refresh_before - Time in seconds before the token is about to expire that it is tried to be automatically refreshed. Defaults to 300 (5 minutes). :http_client - a function that makes the HTTP request. Defaults to using built-in integration with Finch See documentation of the :http_client option in Goth.Token.fetch/1 for more information. :prefetch - how to prefetch the token when the server starts. The possible options are :async to do it asynchronously or :sync to do it synchronously (that is, the server doesn't start until an attempt to fetch the token was made). Defaults to :async . :max_retries - the maximum number of retries (default: 10 ) :retry_delay - a function that receives the retry count (starting at 0) and returns the delay, the number of milliseconds to sleep before making another attempt. Defaults to a simple exponential backoff capped at 30s: 1s, 2s, 4s, 8s, 16s, 30s, 30s, ... Examples Generate a token using a service account credentials file: iex&gt; credentials = &quot;credentials.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) iex&gt; { :ok , _ } = Goth . start_link ( name : MyApp.Goth , source : { :service_account , credentials , [ ] } ) iex&gt; Goth . fetch! ( MyApp.Goth ) % Goth.Token { ... } Retrieve the token using a refresh token: iex&gt; credentials = &quot;credentials.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) iex&gt; { :ok , _ } = Goth . start_link ( name : MyApp.Goth , source : { :refresh_token , credentials , [ ] } ) iex&gt; Goth . fetch! ( MyApp.Goth ) % Goth.Token { ... } Retrieve the token using the Google metadata server: iex&gt; { :ok , _ } = Goth . start_link ( name : MyApp.Goth , source : { :metadata , [ ] } ) iex&gt; Goth . fetch! ( MyApp.Goth ) % Goth.Token { ... }","ref":"Goth.html#start_link/1"},{"type":"module","title":"Goth.Token","doc":"Functions for retrieving the token from the Google API.","ref":"Goth.Token.html"},{"type":"function","title":"Goth.Token.fetch/1","doc":"Fetch the token from the Google API using the given config . Config may contain the following keys: :source - the source to retrieve the token from. Supported values include: {:service_account, credentials} - for fetching token using service account credentials {:refresh_token, credentials} - for fetching token using refresh token :metadata - for fetching token using Google internal metadata service If :source is not set, Goth will: Check application environment. You can set it with: config :goth, json: File.read!(&quot;credentials.json&quot;) . Check GOOGLE_APPLICATION_CREDENTIALS env variable that contains path to credentials file. Check GOOGLE_APPLICATION_CREDENTIALS_JSON env variable that contains credentials JSON. Check ~/.config/gcloud/application_default_credentials.json file. Check Google internal metadata service Otherwise, raise an error. See &quot;Source&quot; section below for more information. :http_client - a function that makes the HTTP request. Can be one of the following: fun - same as {fun, []} {fun, opts} - fun must be a 1-arity function that receives a keyword list with fields :method , :url , :headers , and :body along with any passed opts . The function must return {:ok, %{status: status, headers: headers, body: body}} or {:error, exception} . See &quot;Custom HTTP Client&quot; section below for more information. fun can also be an atom :finch to use the built-in Finch -based client. Defaults to {:finch, []} . Source Source can be one of: Service account - {:service_account, credentials} Same as {:service_account, credentials, []} Service account - {:service_account, credentials, options} The credentials is a map and can contain the following keys: &quot;private_key&quot; &quot;client_email&quot; The options is a keywords list and can contain the following keys: :url - the URL of the authentication service, defaults to: &quot;https://www.googleapis.com/oauth2/v4/token&quot; :scopes - the list of token scopes, defaults to [&quot;https://www.googleapis.com/auth/cloud-platform&quot;] (ignored if :claims present) :claims - self-signed JWT extra claims. Should be a map with string keys only. A self-signed JWT will be exchanged for a Google-signed ID token Refresh token - {:refresh_token, credentials} Same as {:refresh_token, credentials, []} Refresh token - {:refresh_token, credentials, options} The credentials is a map and can contain the following keys: &quot;refresh_token&quot; &quot;client_id&quot; &quot;client_secret&quot; The options is a keywords list and can contain the following keys: :url - the URL of the authentication service, defaults to: &quot;https://www.googleapis.com/oauth2/v4/token&quot; Google metadata server - :metadata Same as {:metadata, []} Google metadata server - {:metadata, options} The options is a keywords list and can contain the following keys: :account - the name of the account to generate the token for, defaults to &quot;default&quot; :url - the URL of the metadata server, defaults to &quot;http://metadata.google.internal&quot; :audience - the audience you want an identity token for, default to nil If this parameter is provided, an identity token is returned instead of an access token Custom HTTP Client To use a custom HTTP client, define a function that receives a keyword list with fields :method , :url , :headers , and :body . The function must return {:ok, %{status: status, headers: headers, body: body}} or {:error, exception} . Here's an example with Finch: defmodule MyApp do def request_with_finch ( options ) do { method , options } = Keyword . pop! ( options , :method ) { url , options } = Keyword . pop! ( options , :url ) { headers , options } = Keyword . pop! ( options , :headers ) { body , options } = Keyword . pop! ( options , :body ) Finch . build ( method , url , headers , body ) |&gt; Finch . request ( Goth.Finch , options ) end end And here is how it can be used: iex&gt; Goth.Token . fetch ( source : source , http_client : &amp; MyApp . request_with_finch / 1 ) { :ok , % Goth.Token { ... } } iex&gt; Goth.Token . fetch ( source : source , http_client : { &amp; MyApp . request_with_finch / 1 , receive_timeout : 5000 } ) { :ok , % Goth.Token { ... } } Examples Generate a token using a service account credentials file: iex&gt; credentials = &quot;credentials.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) iex&gt; Goth.Token . fetch ( source : { :service_account , credentials } ) { :ok , % Goth.Token { ... } } You can generate a credentials file containing service account using gcloud utility like this: $ gcloud iam service-accounts keys create --key-file-type=json --iam-account=... credentials.json Generate a cloud function invocation token using a service account credentials file: iex&gt; credentials = &quot;credentials.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) ...&gt; claims = %{ &quot;target_audience&quot; =&gt; &quot;https://&lt;GCP_REGION&gt;-&lt;PROJECT_ID&gt;.cloudfunctions.net/&lt;CLOUD_FUNCTION_NAME&gt;&quot; } ...&gt; Goth.Token . fetch ( source : { :service_account , credentials , [ claims : claims ] } ) { :ok , % Goth.Token { ... } } Generate an impersonated token using a service account credentials file: iex&gt; credentials = &quot;credentials.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) ...&gt; claims = %{ &quot;sub&quot; =&gt; &quot;&lt;IMPERSONATED_ACCOUNT_EMAIL&gt;&quot; } ...&gt; Goth.Token . fetch ( source : { :service_account , credentials , [ claims : claims ] } ) { :ok , % Goth.Token { ... } } Retrieve the token using a refresh token: iex&gt; credentials = &quot;credentials.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) iex&gt; Goth.Token . fetch ( source : { :refresh_token , credentials } ) { :ok , % Goth.Token { ... } } You can generate a credentials file containing refresh token using gcloud utility like this: $ gcloud auth application-default login Retrieve the token using the Google metadata server: iex&gt; Goth.Token . fetch ( source : :metadata ) { :ok , % Goth.Token { ... } } See Storing and retrieving instance metadata for more information on metadata server. Passing custom Finch options iex&gt; Goth.Token . fetch ( source : source , http_client : { :finch , pool_timeout : 5000 } ) { :ok , % Goth.Token { ... } }","ref":"Goth.Token.html#fetch/1"},{"type":"function","title":"Goth.Token.for_scope/2","doc":"","ref":"Goth.Token.html#for_scope/2"},{"type":"type","title":"Goth.Token.t/0","doc":"","ref":"Goth.Token.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - v1.4.1 (2023-06-27)","doc":"change to OS time to prevent unmanagable clock skew","ref":"changelog.html#v1-4-1-2023-06-27"},{"type":"extras","title":"Changelog - v1.4.0 (2023-03-23)","doc":"Load config from ~/.config/gcloud/configurations/config_default","ref":"changelog.html#v1-4-0-2023-03-23"},{"type":"extras","title":"Changelog - v1.3.1 (2022-08-10)","doc":"Force refresh whenever cached token is expired Fix getting tokens from metadata with no options provide","ref":"changelog.html#v1-3-1-2022-08-10"},{"type":"extras","title":"Changelog - v1.3.0 (2022-06-29)","doc":"Add Goth.start_link/1 , Goth.fetch/2 , Goth.fetch!/2 , and Goth.Token.fetch/1 . Deprecations: Goth.Token : Deprecate for_scope/2 , from_response_json/2 , refresh!/1 Deprecate Goth.Client module Deprecate Goth.Config module Deprecate Goth.TokenStore module","ref":"changelog.html#v1-3-0-2022-06-29"},{"type":"extras","title":"Goth","doc":"Google + Auth = Goth A simple library to generate and retrieve OAuth2 tokens for use with Google Cloud Service accounts.","ref":"readme.html"},{"type":"extras","title":"Goth - Installation","doc":"Note: below are instructions for using Goth v1.3+. For more information on earlier versions of Goth, see v1.2.0 documentation on hexdocs.pm . Add :goth to your list of dependencies in mix.exs . def deps do [ { :goth , &quot;~&gt; 1.3&quot; } ] end Add Goth to your supervision tree: defmodule MyApp.Application do use Application def start ( _type , _args ) do credentials = &quot;GOOGLE_APPLICATION_CREDENTIALS_JSON&quot; |&gt; System . fetch_env! ( ) |&gt; Jason . decode! ( ) source = { :service_account , credentials } children = [ { Goth , name : MyApp.Goth , source : source } ] Supervisor . start_link ( children , strategy : :one_for_one ) end end If you set GOOGLE_APPLICATION_CREDENTIALS or GOOGLE_APPLICATION_CREDENTIALS_JSON , have a ~/.config/gcloud/application_default_credentials.json file, ~/.config/gcloud/configurations/config_default file or deploy your application to Google Cloud, you can omit the :source option: def start ( _type , _args ) do children = [ { Goth , name : MyApp.Goth } ] Supervisor . start_link ( children , strategy : :one_for_one ) end If you want to use multiple credentials, you may consider doing: def start ( _type , _args ) do Supervisor . start_link ( servers ( ) , strategy : :one_for_one ) end defp servers do servers = [ { MyApp.Cred1 , source1 } , ... { MyApp.CredN , source2 } ] for { name , source } &lt;- servers do Supervisor . child_spec ( { Goth , name : name , source : source } , id : name ) end end Fetch the token: iex&gt; Goth . fetch! ( MyApp.Goth ) % Goth.Token { expires : 1453356568 , token : &quot;ya29.cALlJ4ICWRvMkYB-WsAR-CZnExE459PA7QPqKg5nei9y2T9-iqmbcgxq8XrTATNn_BPim&quot; , type : &quot;Bearer&quot; , ... } See Goth.start_link/1 for more information about possible configuration options.","ref":"readme.html#installation"},{"type":"extras","title":"Goth - Upgrading from Goth 1.2","doc":"See Upgrading from Goth 1.2 guide for more information.","ref":"readme.html#upgrading-from-goth-1-2"},{"type":"extras","title":"Goth - Community resources","doc":"How to upload on YouTube Data API with elixir ?","ref":"readme.html#community-resources"},{"type":"extras","title":"Goth - Copyright and License","doc":"Copyright (c) 2016 Phil Burrows This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Upgrading from Goth 1.2","doc":"Earlier versions of Goth relied on global application environment configuration which is deprecated in favour of a more direct and explicit approach in Goth v1.3+. Below is a step-by-step upgrade path from Goth 1.x to 1.3: Change your mix.exs : def deps do [ { :goth , &quot;~&gt; 1.3-rc&quot; } ] end You might have code similar to this: # config/config.exs config :goth , json : { :system , &quot;GCP_CREDENTIALS&quot; } # lib/myapp.ex defmodule MyApp do def gcloud_authorization ( ) do { :ok , token } = Goth.Token . for_scope ( &quot;https://www.googleapis.com/auth/cloud-platform.read-only&quot; ) &quot; \#{ token . type } \#{ token . token } &quot; end end Replace it with: defmodule MyApp.Application do @moduledoc false use Application def start ( _type , _args ) do credentials = &quot;GCP_CREDENTIALS&quot; |&gt; System . fetch_env! ( ) |&gt; Jason . decode! ( ) scopes = [ &quot;https://www.googleapis.com/auth/cloud-platform.read-only&quot; ] source = { :service_account , credentials , scopes : scopes } children = [ { Goth , name : MyApp.Goth , source : source } ] Supervisor . start_link ( children , strategy : :one_for_one ) end end # lib/myapp.ex defmodule MyApp do def gcloud_authorization ( ) do { :ok , token } = Goth . fetch ( MyApp.Goth ) &quot; \#{ token . type } \#{ token . token } &quot; end end For more information on earlier versions of Goth, see v1.2.0 documentation on hexdocs.pm .","ref":"upgrade_guide.html"},{"type":"extras","title":"The MIT License (MIT)","doc":"Copyright (c) 2016 Phil Burrows Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]